ant = new AntBuilder()
ant.property( file:'build.properties' )
prop = ant.project.properties

undeploy = {
  ant.delete( file : "${prop['webapps.dir']}/${prop['war.name']}" )
}

compile = {
  ant.sequential {
    mkdir( dir : "${prop['war.dir']}/WEB-INF/classes" )
    taskdef(  name : 'groovyc', classname : 'org.codehaus.groovy.ant.Groovyc' )
    groovyc( srcdir : "${prop['src.dir']}/scripts", destdir : "${prop['war.dir']}/WEB-INF/classes" )
  }
}

clean = {
  ant.sequential {
    delete( file : prop['war.name'] )
    delete( dir : prop['war.dir'] )
  }
}

copyScript = {
  ant.sequential {
    mkdir( dir : "${prop['war.dir']}/WEB-INF/groovy" )
    copy( todir  : "${prop['war.dir']}/WEB-INF/groovy" ) {
      fileset( dir : "${prop['src.dir']}/scripts" ) {
        include( name : '**/*.groovy' )
      }
    }
  }
}

war = {
  ant.sequential {
    mkdir( dir : prop['war.dir'] )
    copy( todir : prop['war.dir'] ) {
      fileset( dir : "${prop['src.dir']}/web" ) {
        include( name : '*.groovy' )
        include( name : '*.css' )
      }
    }

    mkdir( dir : "${prop['war.dir']}/WEB-INF" )
    copy( todir : "${prop['war.dir']}/WEB-INF",
          file : "${prop['src.dir']}/etc/web.xml" )

    mkdir( dir : "${prop['war.dir']}/WEB-INF/lib" )
    copy( todir : "${prop['war.dir']}/WEB-INF/lib", file : prop['jdbc.jar'] )
    copy( todir : "${prop['war.dir']}/WEB-INF/lib", file : prop['groovy.jar'] )

    war( destfile : prop['war.name'],
         webxml : "${prop['war.dir']}/WEB-INF/web.xml" ) {
      fileset( dir : "${prop['war.dir']}" )
    }
  }
}

deploy = {
  ant.copy( todir : "${prop['webapps.dir']}", file  : prop['war.name'] )
}

warScript = {
  clean()
  copyScript()
  war()
}

warCompile = {
  clean()
  compile()
  war()
}

try {
  if (args)  {
    args.each { "${it}"() }
  } else {
    warScript()
  }
} catch( ex ) {
  println '̏sł܂ł'
}
