package miniblog

class Controller  {

  def script
  def auth
  def page

  def exec()  {
    if ( auth  &&  script.session?.login?.length() < 1 )  {
      script.response.sendRedirect( 'login.groovy' )
    }  else  {
      try {
        init()
        return page.exec( script, new Renderer(), Database.getInstance() )
      } catch( ex ) {
        return ex.toString()
      }
    }
  }

  def getEncoding()  {
    try {
      return page.encoding
    } catch( ex ) {}
    'Shift_JIS'
  }

  private init()  {
    script.params.each {
      def param = new String( it.value.getBytes( "ISO-8859-1" ), getEncoding() )
      param = ( param ) ? param : ''
      script.params[it.key] = param
    }
    script.session = (script.session) ? script.session : script.request.getSession()
    script.response.setHeader( 'Content-Type', getContentType() )
  }

  private getContentType()  {
    getMimeType() + ';charset=' + getEncoding()
  }

  private getMimeType()  {
    try {
      return page.mimeType
    } catch( ex ) {}
    'text/html'
  }

}