package miniblog

import groovy.sql.Sql

class Database {

  private static db = null

  static getInstance() {
    if ( !db ) db = new Database()
    db
  }

  def sql = Sql.newInstance( 'jdbc:mysql://localhost:3306/groovydb',
                             'root', 'admin', 'com.mysql.jdbc.Driver' )

  def regist(User user) {
    sql.executeUpdate( "INSERT INTO user(name, pass) VALUES (?, PASSWORD(?))", [user.name, user.pass] )
  }

  def remove(User user) {
    sql.executeUpdate( 'UPDATE user SET date_delete = CURRENT_TIMESTAMP WHERE date_delete = 0 AND name = ? AND pass = PASSWORD(?)', [user.name, user.pass] )
  }

  boolean auth(User user) {
    def row = sql.firstRow( "SELECT count(*) FROM user WHERE name = ? AND pass = PASSWORD(?) AND date_delete = 0", [user.name, user.pass] )
    row[0]
  }

  def post(Miniblog miniblog) {
    sql.execute( "INSERT INTO miniblog(user_id, message) VALUES ((SELECT id FROM user WHERE name = ? AND date_delete = 0), ?)", [miniblog.user.name, miniblog.message] )
  }

  def messages() {
    def rows = []
    sql.eachRow( "SELECT u.name, mb.message, mb.date_create FROM user u, miniblog mb WHERE u.id = mb.user_id ORDER BY mb.date_create DESC" ) {
      rows << new Miniblog( user:new User(name:it[0]), message:it[1], dt:it[2] )
    }
    rows
  }

  def messages(User user) {
    def rows = []
    sql.eachRow( "SELECT u.name, mb.message, mb.date_create FROM user u, miniblog mb WHERE u.id = mb.user_id AND u.name = ? ORDER BY mb.date_create DESC", [user.name] ) {
      rows << new Miniblog( user:new User(name:it[0]), message:it[1], dt:it[2] )
    }
    rows
  }

  public void finalize()  {
    if (db)  try { db.close() } catch( ex ) {}
  }

}
