package miniblog.page

import miniblog.*

class Post  {

  def exec( script, renderer, db )  {

    def user    = new User( name:script.session.user )
    def message = script.params['message']

    def defaultMessage = 'bZ[W𓊍e'
    def display = '܂łɓeꂽbZ[W'
    if ( message != null  &&  message != defaultMessage  &&  message.trim().length() > 0 )  {
      try  {
        db.post( new Miniblog( user: user, message : message.trim() ) )
      } catch( ex ) {
        display = 'bZ[W𓊍eł܂ł'
      }
    }

    def messages = []
    if ( script.params.post )  {
      messages = db.messages()
    } else if ( script.params.name )  {
      display = "[U[${script.params.name}ebZ[W"
      messages = db.messages( new User( name:script.params.name ) )
    } else {
      display = "OC[U[ebZ[W"
      messages = db.messages( user )
    }

    def form = renderer.renderTemplate( Renderer.postForm, ['name':script.session.user, 'defaultMessage':defaultMessage, 'display':display] )

    renderer.renderTemplate( Renderer.HTML,
      ['body':form + renderer.renderMessages( messages )] )

  }

}